﻿local StoneGateV8 = foundation.createMod();

-- Check the game version
if (foundation.getGameVersion == nil) or (version.cmp(foundation.getGameVersion(), "1.7") < 0) then
    StoneGateV8:logError("StoneGateV8: game version anterior to 1.7")
    return
end
_scriptFolder = "scripts1.8"
if (version.cmp(foundation.getGameVersion(), "1.8") < 0) then
    _scriptFolder = "scripts1.7"
end
StoneGateV8:msgBox("StoneGateV8: game version" .. foundation.getGameVersion())

-- Set the mod major versions
StoneGateSetPrefix = "STONE_GATE_V8"
StoneGateSetPrefixWhiteFloor = "STONE_GATE_V8_WF"
CommonWindowPrefix = "CUSTOM_WINDOW_V3"
CommonDoorPrefix = "CUSTOM_DOOR_V3"
CommonFlagPrefix = "CUSTOM_FLAG_V3"
AssemblagePrefix = "ASSEMBLAGE_V1"

-- common functions
-- As the global functions are not transmit yet from dependencies, this file has to be duplicated in each mod
StoneGateV8:dofile(_scriptFolder .. "/customTheme.lua")
StoneGateV8:dofile(_scriptFolder .. "/common.lua", StoneGateSetPrefix, CommonWindowPrefix, StoneGateSetPrefixWhiteFloor, CommonDoorPrefix, CommonFlagPrefix, AssemblagePrefix )

_NoSandbox = difficultyLevel(StoneGateV8, "StoneGateV8")

-- check all the dependencies
if not checkVersion(StoneGateV8, "StoneGateV8", "Window Decorations V3", "9f9781bd-0bb9-4e83-a71c-3688c27bf698", "3.0.3") then
    return 
end

_flagHarbourV2 = foundation.isModEnabled("595ec1ef-de7e-44d1-94f6-e8ffae346ff1")

StoneGateV8:dofile(_scriptFolder .. "/monument.lua")
