local StoneGate, StoneGateExtensionPrefix = ...

-- Apply building asset processor
StoneGate:registerAssetProcessor("models/woodenFloors/woodenFloorMainWhite.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/woodenFloors/woodenFloorKeepWhite.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/woodenFloors/woodenFloorSmallSquaredTowerWhite.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/woodenFloors/woodenFloorSmallGateWhite.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/woodenFloors/woodenFloorCircularTowerWhite.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/woodenFloors/woodenFloorOctogonalTowerWhite.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/woodenFloors/woodenFloorSmallCircularTowerWhite.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGate:registerAssetProcessor("models/woodenFloors/woodenFloorAngle45White.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

function registerWoodenFloorOptionPart(_option)
function registerWoodenFloorPart(_nameFbxFile, _nameFbx, _nameAsset, _villagerCapacity)
    StoneGate:registerAssetId("models/woodenFloors/" .. _nameFbxFile .. ".fbx/Prefab/woodenFloor/" .. _nameFbx .. "Part", StoneGateExtensionPrefix .. "_" .. _nameAsset .. "_PREFAB")

-- Register the stone gate set decoration roof part
    StoneGate:register({
	DataType = "BUILDING_PART",
	Id = StoneGateExtensionPrefix .. "_" .. _nameAsset .. "_PART",
	Name = StoneGateExtensionPrefix .. "_" .. _nameAsset .. "_NAME",
	Description = StoneGateExtensionPrefix .. "_" .. _nameAsset .. "_DESC",
	Category = "EXTENSION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = StoneGateExtensionPrefix .. "_" .. _nameAsset .. "_PREFAB",
                MiniatureConfig = {
                        DataType = "BUILDING_MINIATURE_CONFIG",
                        ClipUnderGround = false
                }
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "PLANK", Quantity = 5*_NoSandbox }
		}
	},
    })
end

    registerWoodenFloorPart( "woodenFloorMainWhite", "step_2_WFMain" .. _option, "WFMAIN_" .. _option, 12 )
    registerWoodenFloorPart( "woodenFloorKeepWhite", "step_2_WFKeep" .. _option, "WFKEEP_" .. _option, 8 )
    registerWoodenFloorPart( "woodenFloorSmallSquaredTowerWhite", "step_2_WFSst" .. _option, "WFSST_" .. _option, 2 )
    registerWoodenFloorPart( "woodenFloorSmallGateWhite", "step_2_WFSGate" .. _option, "WFSGATE_" .. _option, 2 )
    registerWoodenFloorPart( "woodenFloorAngle45White", "step_2_WFA45" .. _option, "WFA45_" .. _option, 0 )
    registerWoodenFloorPart( "woodenFloorOctogonalTowerWhite", "step_2_WFOctogonal" .. _option, "WFOTOWER_" .. _option, 8 )
    registerWoodenFloorPart( "woodenFloorCircularTowerWhite", "step_2_WFCircular" .. _option, "WFCIRCULAR_" .. _option, 6 )
    registerWoodenFloorPart( "woodenFloorSmallCircularTowerWhite", "step_2_WFSct" .. _option, "WFSCT_" .. _option, 0 )
end

registerWoodenFloorOptionPart("A")
registerWoodenFloorOptionPart("B")
registerWoodenFloorOptionPart("C")

function registerWoodenFloorPlatform(_nameFbxFile, _nameFbx)
    StoneGate:configurePrefabFlagList("models/woodenFloors/" .. _nameFbxFile .. ".fbx/Prefab/woodenFloor/" .. _nameFbx .. "Part", { "PLATFORM" })
end
registerWoodenFloorPlatform( "woodenFloorSmallGateWhite", "step_2_WFSGateA")
registerWoodenFloorPlatform( "woodenFloorSmallGateWhite", "step_2_WFSGateB")
registerWoodenFloorPlatform( "woodenFloorSmallGateWhite", "step_2_WFSGateC")
