local Assemblage, _HomePrefix = ...

---------------------------------------------------------------------------------------------------
-- Versions V8.0.1
---------------------------------------------------------------------------------------------------
-- several models of door
    Assemblage:registerAsset({
	DataType = "BUILDING_PART",
	Id = _HomePrefix .. "_WOOD_DOOR_PART",
	ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
  		            CommonDoorPrefix .. "_ENTRANCE_WOODEN_DOOR_C_PART",
  		            CommonDoorPrefix .. "_ENTRANCE_WOODEN_DOOR_D_PART",
  		            CommonDoorPrefix .. "_ENTRANCE_WOODEN_DOOR_E_PART",
                          }
        }
    })
    Assemblage:registerAsset({
	DataType = "BUILDING_PART",
	Id = _HomePrefix .. "_STONE_DOOR_PART",
	ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
 		            CommonDoorPrefix .. "_ENTRANCE_DOOR_A_PART",
  		            CommonDoorPrefix .. "_ENTRANCE_DOOR_B_PART",
                          }
        }
    })

-- several models of window
    Assemblage:registerAsset({
	DataType = "BUILDING_PART",
	Id = _HomePrefix .. "_WOOD_WINDOW_PART",
	ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
		            CommonWindowPrefix .. "_DECORATION_WOODEN_WINDOW_1_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_WINDOW_18_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_WINDOW_3_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_WINDOW_9_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_WINDOW_7_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_WINDOW_8_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_LARGE_WINDOW_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_POINTED_WINDOW_1_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_ROUND_WINDOW_PART",
		            CommonWindowPrefix .. "_DECORATION_WOODEN_AMERICAN_WINDOW_1_PART",
                          }
        }
    })
    Assemblage:registerAsset({
	DataType = "BUILDING_PART",
	Id = _HomePrefix .. "_STONE_WINDOW_PART",
	ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
		            CommonWindowPrefix .. "_DECORATION_SFENETRE_PART",
		            CommonWindowPrefix .. "_DECORATION_LFENETRE_PART",
		            CommonWindowPrefix .. "_DECORATION_PFENETRE_PART",
		            CommonWindowPrefix .. "_DECORATION_ARROWSLIT_PART",
		            CommonWindowPrefix .. "_DECORATION_BALCONY_PART",
                          }
        }
    })

function registerRandomCore(_option, _core, _buildingZone, _villagerCapacity)
    function registerGroundFloorAssemblage(_buildingAssetId, _namePrefab, _material)
        function assignWindowsGroundFloor()
            -- MAIN floor: 1 door + 9 optional windows
            if (_core == "MAIN") then
                return {
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_DOOR_PART", Probability = 1 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_"  .. _material .. "_WINDOW_PART", Probability = 0.5 },
                }
            end
            -- KEEP or Octogonal Tower floor: 1 door + 7 optional windows
            if ((_core == "KEEP") or (_core == "OTOWER") or (_core == "CIRCULAR")) then
                return {
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_DOOR_PART", Probability = 1 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                }
            end
            -- Small Squared Tower floor: 1 door + 3 optional windows
            if ((_core == "SST") or (_core == "SCT")) then
                return {
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_DOOR_PART", Probability = 1 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                }
            end
            return {}
        end

    -- Register the main assemblage
        Assemblage:registerAsset({
	    DataType = "BUILDING_PART",
	    Id = _HomePrefix .. "_" .. _buildingAssetId .. "_PART",
	    Name = _HomePrefix .. "_" .. _buildingAssetId .. "_NAME",
	    Description = _HomePrefix .. "_" .. _buildingAssetId .. "_DESC",
	    Category = "CORE",
	    BuildingZone = _buildingZone,
	    ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { _namePrefab },
                MandatoryBuildingPartList = assignWindowsGroundFloor(),
                AssemblageSetList = { {  DataType = "ASSEMBLAGE_CUSTOM_SET",
                                         CustomValueList = {
                                               { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_" .. _material .. "_NEXT_FLOOR_PART",
                                                 AttachNodeString = "Attach_Major_rcv1mhw"
                                               }
                                         }                    
                }},
            },
            Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = _NoSandbox*0 }
		},
		ResourceNeededList = {{
			{ Resource = _material, Quantity = _NoSandbox*10 }
		}}
	    },
       })
    end

-- several models of roof
    if ((_core == "MAIN") or (_core == "KEEP") or (_core == "SST"))then
        function registerPinionExtension(_angle, _sizePinion, _typePinion, _extensionAttachName)
            Assemblage:registerAsset({
	        DataType = "BUILDING_PART",
	        Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_ROOF_EXTENSION" .. _angle .. "_PART",
         	ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
                              StoneGateSetPrefix .. "_" .. _typePinion .. "_ROOF_EXTENSION_ADVANCED" .. _angle .. "_PART",
                              StoneGateSetPrefix .. "_" .. _typePinion .. "_ROOF_EXTENSION_STRAIGHT" .. _angle .. "_PART",
                          }                    
                },
            })
            function registerWoodPinion(_modelPinion, _MODEL_PINION)
                Assemblage:registerAsset({
	            DataType = "BUILDING_PART",
	            Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_DECORATION_" .. _MODEL_PINION .. _angle .. "_PART",
	            ConstructorData = {
		        DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		        CoreRandomBuildingPartList = { StoneGateSetPrefix .. "_DECORATION_" .. _MODEL_PINION .. _angle .. "_PREFAB" },
                        AssemblageSetList = { {  DataType = "ASSEMBLAGE_CUSTOM_SET",
                                         CustomValueList = {
                                               { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_ROOF_EXTENSION" .. _angle .. "_PART",
                                                 AttachNodeString = "Attach_" .. _modelPinion .. _angle .. "1"
                                               },
                                         }                    
                        }},
                    },
                })
            end
            registerWoodPinion(_extensionAttachName .. "SimpleWhite", "PINION" .. _sizePinion .. "_SIMPLE_WHITE")
            registerWoodPinion(_extensionAttachName .. "SimpleWood", "PINION" .. _sizePinion .. "_SIMPLE_WOOD")
            Assemblage:registerAsset({
	        DataType = "BUILDING_PART",
	        Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_DECORATION_PINION" .. _angle .. "_PART",
         	ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
                              _HomePrefix .. "_" .. _option .. "_" .. _core .. "_DECORATION_PINION" .. _sizePinion .. "_SIMPLE_WHITE" .. _angle .. "_PART",
                              _HomePrefix .. "_" .. _option .. "_" .. _core .. "_DECORATION_PINION" .. _sizePinion .. "_SIMPLE_WOOD" .. _angle .. "_PART",
                          }                    
                },
            })
        end
    end

    if ((_core == "KEEP") or (_core == "SST")) then
        function registerWoodRoofKeepOrSst(_angle, _attachPrefix, _attachSuffix)
            Assemblage:registerAsset({
	        DataType = "BUILDING_PART",
	        Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_2OPPOSITE" .. _angle .. "_PART",
	        ConstructorData = {
		    DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		    CoreRandomBuildingPartList = { StoneGateSetPrefix .. "_" .. _core .. "_ROOF_2OPPOSITE" .. _angle .. "_PREFAB" },
                    AssemblageSetList = { {  DataType = "ASSEMBLAGE_CUSTOM_SET",
                                         CustomValueList = {
                                               { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_DECORATION_PINION" .. _angle .. "_PART",
                                                 AttachNodeString = "Attach_" .. _attachPrefix .. "_L_" .. _attachSuffix .. "2Opposite" .. _angle
                                               },
                                               { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_DECORATION_PINION" .. _angle .. "_PART",
                                                 AttachNodeString = "Attach_" .. _attachPrefix .. "_R_" .. _attachSuffix .. "2Opposite" .. _angle
                                               },
                                         }                    
                    }},
                },
            })
            Assemblage:registerAsset({
	        DataType = "BUILDING_PART",
	        Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_2ADJACENT" .. _angle .. "_PART",
	        ConstructorData = {
		    DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		    CoreRandomBuildingPartList = { StoneGateSetPrefix .. "_" .. _core .. "_ROOF_2ADJACENT" .. _angle .. "_PREFAB" },
                    AssemblageSetList = { {  DataType = "ASSEMBLAGE_CUSTOM_SET",
                                         CustomValueList = {
                                               { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_DECORATION_PINION" .. _angle .. "_PART",
                                                 AttachNodeString = "Attach_" .. _attachPrefix .. "_R_" .. _attachSuffix .. "2Adjacent" .. _angle
                                               },
                                               { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_DECORATION_PINION" .. _angle .. "_PART",
                                                 AttachNodeString = "Attach_" .. _attachPrefix .. "_B_" .. _attachSuffix .. "2Adjacent" .. _angle
                                               },
                                         }                    
                    }},
                },
            })
            Assemblage:registerAsset({
	        DataType = "BUILDING_PART",
	        Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_3OPENED" .. _angle .. "_PART",
	        ConstructorData = {
		    DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		    CoreRandomBuildingPartList = { StoneGateSetPrefix .. "_" .. _core .. "_ROOF_3OPENED" .. _angle .. "_PREFAB" },
                    AssemblageSetList = { {  DataType = "ASSEMBLAGE_CUSTOM_SET",
                                         CustomValueList = {
                                               { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_DECORATION_PINION" .. _angle .. "_PART",
                                                 AttachNodeString = "Attach_" .. _attachPrefix .. "_L_" .. _attachSuffix .. "3Opened" .. _angle
                                               },
                                               { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_DECORATION_PINION" .. _angle .. "_PART",
                                                 AttachNodeString = "Attach_" .. _attachPrefix .. "_R_" .. _attachSuffix .. "3Opened" .. _angle
                                               },
                                               { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_DECORATION_PINION" .. _angle .. "_PART",
                                                 AttachNodeString = "Attach_" .. _attachPrefix .. "_B_" .. _attachSuffix .. "3Opened" .. _angle
                                               },
                                         }                    
                    }},
                },
            })
            Assemblage:registerAsset({
	        DataType = "BUILDING_PART",
	        Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_1OPENED" .. _angle .. "_PART",
	        ConstructorData = {
		    DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		    CoreRandomBuildingPartList = { StoneGateSetPrefix .. "_" .. _core .. "_ROOF_1OPENED" .. _angle .. "_PREFAB" },
                    AssemblageSetList = { {  DataType = "ASSEMBLAGE_CUSTOM_SET",
                                         CustomValueList = {
                                               { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_DECORATION_PINION" .. _angle .. "_PART",
                                                 AttachNodeString = "Attach_" .. _attachPrefix .. "_R_" .. _attachSuffix .. "1Opened" .. _angle
                                               },
                                         }                    
                    }},
                },
            })
            Assemblage:registerAsset({
	        DataType = "BUILDING_PART",
	        Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_4OPENED" .. _angle .. "_PART",
	        ConstructorData = {
		    DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		    CoreRandomBuildingPartList = { StoneGateSetPrefix .. "_" .. _core .. "_ROOF_4OPENED" .. _angle .. "_PREFAB" },
                    AssemblageSetList = { {  DataType = "ASSEMBLAGE_CUSTOM_SET",
                                         CustomValueList = {
                                               { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_DECORATION_PINION" .. _angle .. "_PART",
                                                 AttachNodeString = "Attach_" .. _attachPrefix .. "_L_" .. _attachSuffix .. "4Opened" .. _angle
                                               },
                                               { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_DECORATION_PINION" .. _angle .. "_PART",
                                                 AttachNodeString = "Attach_" .. _attachPrefix .. "_R_" .. _attachSuffix .. "4Opened" .. _angle
                                               },
                                               { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_DECORATION_PINION" .. _angle .. "_PART",
                                                 AttachNodeString = "Attach_" .. _attachPrefix .. "_B_" .. _attachSuffix .. "4Opened" .. _angle
                                               },
                                               { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_DECORATION_PINION" .. _angle .. "_PART",
                                                 AttachNodeString = "Attach_" .. _attachPrefix .. "_F_" .. _attachSuffix .. "4Opened" .. _angle
                                               },
                                         }                    
                    }},
                },
            })
        end
    end

    if (_core == "MAIN") then
        function registerPinion(_angle)
            registerPinionExtension(_angle, "2", "KEEP", "StoneGatePinion_Pinion2")
            Assemblage:registerAsset({
	        DataType = "BUILDING_PART",
	        Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_2OPPOSITE" .. _angle .. "_PART",
	        ConstructorData = {
		    DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		    CoreRandomBuildingPartList = { StoneGateSetPrefix .. "_" .. _core .. "_ROOF_2OPPOSITE" .. _angle .. "_PREFAB" },
                    AssemblageSetList = { {  DataType = "ASSEMBLAGE_CUSTOM_SET",
                                         CustomValueList = {
                                               { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_DECORATION_PINION" .. _angle .. "_PART",
                                                 AttachNodeString = "Attach_StoneGatePinion_L_sgv8mr2o" .. _angle
                                               },
                                               { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_DECORATION_PINION" .. _angle .. "_PART",
                                                 AttachNodeString = "Attach_StoneGatePinion_R_sgv8mr2o" .. _angle
                                               },
                                         }                    
                    }},
                },
            })
            Assemblage:registerAsset({
	        DataType = "BUILDING_PART",
	        Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_1OPENED" .. _angle .. "_PART",
	        ConstructorData = {
		    DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		    CoreRandomBuildingPartList = { StoneGateSetPrefix .. "_" .. _core .. "_ROOF_1OPENED" .. _angle .. "_PREFAB" },
                    AssemblageSetList = { {  DataType = "ASSEMBLAGE_CUSTOM_SET",
                                         CustomValueList = {
                                               { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_DECORATION_PINION" .. _angle .. "_PART",
                                                 AttachNodeString = "Attach_StoneGatePinion_R_sgv8mr1o" .. _angle
                                               },
                                         }                    
                    }},
                },
            })
        end
        registerPinion("45")
        registerPinion("30")
        registerPinion("60")

        Assemblage:registerAsset({
	    DataType = "BUILDING_PART",
	    Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_PART",
	    ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
		            StoneGateSetPrefix .. "_MAIN_ROOF_4CLOSED45_PART",   -- Closed roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_2OPPOSITE45_PART", -- Opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_1OPENED45_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_4CLOSED30_PART",   -- Closed roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_2OPPOSITE30_PART", -- Opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_1OPENED30_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_4CLOSED60_PART",   -- Closed roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_2OPPOSITE60_PART", -- Opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_1OPENED60_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_DOME_4CLOSED_PART",   -- Closed roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_DOME_2OPPOSITE_PART", -- Opened roof
		            StoneGateSetPrefix .. "_MAIN_ROOF_DOME_1OPENED_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_MAIN_POINTED_ROOF_4CLOSED_PART",   -- Closed roof
		            StoneGateSetPrefix .. "_MAIN_POINTED_ROOF_2OPPOSITE_PART", -- Opened roof
		            StoneGateSetPrefix .. "_MAIN_POINTED_ROOF_1OPENED_PART",   -- half opened roof
                         }
            }
        })

    elseif (_core == "KEEP") then
        function registerPinion(_angle)
            registerPinionExtension(_angle, "2", "KEEP", "StoneGatePinion_Pinion2")
            registerWoodRoofKeepOrSst(_angle, "StoneGatePinion", "Roof")
        end
        registerPinion("45")
        registerPinion("30")
        registerPinion("60")

        Assemblage:registerAsset({
	    DataType = "BUILDING_PART",
            Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_PART",
	    ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
		            StoneGateSetPrefix .. "_KEEP_ROOF_4CLOSED45_PART",   -- Closed roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_2OPPOSITE45_PART", -- Opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_1OPENED45_PART",   -- half opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_2ADJACENT45_PART",   -- half opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_3OPENED45_PART",   -- half opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_4OPENED45_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_4CLOSED30_PART",   -- Closed roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_2OPPOSITE30_PART", -- Opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_1OPENED30_PART",   -- half opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_2ADJACENT30_PART",   -- half opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_3OPENED30_PART",   -- half opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_4OPENED30_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_4CLOSED60_PART",   -- Closed roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_2OPPOSITE60_PART", -- Opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_1OPENED60_PART",   -- half opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_2ADJACENT60_PART",   -- half opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_3OPENED60_PART",   -- half opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_4OPENED60_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_DOME_4CLOSED_PART",   -- Closed roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_DOME_2OPPOSITE_PART", -- Opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_DOME_1OPENED_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_DOME_2ADJACENT_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_DOME_3OPENED_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_ROOF_DOME_4OPENED_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_POINTED_ROOF_4CLOSED_PART",   -- Closed roof
		            StoneGateSetPrefix .. "_KEEP_POINTED_ROOF_2OPPOSITE_PART", -- Opened roof
		            StoneGateSetPrefix .. "_KEEP_POINTED_ROOF_1OPENED_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_POINTED_ROOF_2ADJACENT_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_POINTED_ROOF_3OPENED_PART",   -- half opened roof
		            StoneGateSetPrefix .. "_KEEP_POINTED_ROOF_4OPENED_PART",   -- half opened roof
                         }
            }
        })

    elseif (_core == "SST") then
        function registerPinion(_angle)
            registerPinionExtension(_angle, "1", "SST", "Minor_pinion_R_Pinion1")
            registerWoodRoofKeepOrSst(_angle, "Minor_pinion", "sgv8sstr")
        end
        registerPinion("45")
        registerPinion("30")
        registerPinion("60")

        Assemblage:registerAsset({
	    DataType = "BUILDING_PART",
            Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_PART",
	    ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
		            StoneGateSetPrefix .. "_SST_ROOF_4CLOSED45_PART",   -- Closed roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_2OPPOSITE45_PART", -- Opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_1OPENED45_PART",   -- 1 opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_2ADJACENT45_PART", -- 2 adjacent opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_3OPENED45_PART",   -- 3 opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_4OPENED45_PART",   -- 4 opened roof
		            StoneGateSetPrefix .. "_SST_ROOF_4CLOSED30_PART",   -- Closed roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_2OPPOSITE30_PART", -- Opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_1OPENED30_PART",   -- 1 opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_2ADJACENT30_PART", -- 2 adjacent opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_3OPENED30_PART",   -- 3 opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_4OPENED30_PART",   -- 4 opened roof
		            StoneGateSetPrefix .. "_SST_ROOF_4CLOSED60_PART",   -- Closed roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_2OPPOSITE60_PART", -- Opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_1OPENED60_PART",   -- 1 opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_2ADJACENT60_PART", -- 2 adjacent opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_3OPENED60_PART",   -- 3 opened roof
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_4OPENED60_PART",   -- 4 opened roof
		            StoneGateSetPrefix .. "_SST_POINTED_ROOF_2OPPOSITE_PART", -- 2 opposite sides opened
		            StoneGateSetPrefix .. "_SST_POINTED_ROOF_1OPENED_PART",   -- 1 side opened roof
		            StoneGateSetPrefix .. "_SST_POINTED_ROOF_4CLOSED_PART",   -- Closed roof
		            StoneGateSetPrefix .. "_SST_POINTED_ROOF_2ADJACENT_PART", -- 2 adjacent sides opened
                         }
            }
        })

    elseif ((_core == "OTOWER") or (_core == "CIRCULAR") or (_core == "SCT")) then
        Assemblage:registerAsset({
	    DataType = "BUILDING_PART",
            Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_PART",
	    ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
                             StoneGateSetPrefix .. "_" .. _core .. "_ROOF45_PART",
                             StoneGateSetPrefix .. "_" .. _core .. "_ROOF30_PART",
                             StoneGateSetPrefix .. "_" .. _core .. "_ROOF60_PART",
                             StoneGateSetPrefix .. "_" .. _core .. "_ROOF_DOME_PART",
                             StoneGateSetPrefix .. "_" .. _core .. "_POINTED_ROOF_PART",
                          },
            }
        })
    end

    function registerFloorAssemblage(_name, _nameModel, _material)
-- Register the extra floor assemblage
        function assignWindows()
            -- MAIN floor: 10 optional windows
            if (_core == "MAIN") then
                return {
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                }
            end
            -- KEEP or Octogonal Tower floor: 8 optional windows
            if ((_core == "KEEP") or (_core == "OTOWER") or (_core == "CIRCULAR")) then
                return {
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                }
            end
            -- Small Squared Tower floor: 4 optional windows
            if ((_core == "SST") or (_core == "SCT")) then
                return {
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                    { BuildingPart = _HomePrefix .. "_" .. _material .. "_WINDOW_PART", Probability = 0.5 },
                }
            end
            return {}
        end
        
        function assignNextFloor()
            if (_name == _option .. "_OTOWER_TILING2") then
                return _HomePrefix .. "_" .. _option .. "_OTOWER_TILING3_PART" 
            elseif (_name == _option .. "_OTOWER_TILING2P") then
                return _HomePrefix .. "_" .. _option .. "_OTOWER_TILING3P_PART" 
            else
                return _HomePrefix .. "_" .. _option .. "_" .. _core .. "_" .. _material .. "_NEXT_FLOOR_PART"
            end               
        end

        Assemblage:registerAsset({
	    DataType = "BUILDING_PART",
	    Id = _HomePrefix .. "_" .. _name .. "_PART",
	    ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { _nameModel .. "_PREFAB" },
                MandatoryBuildingPartList = assignWindows(),
                AssemblageSetList = { {  DataType = "ASSEMBLAGE_CUSTOM_SET",
                                         CustomValueList = {
                                               { BuildingPart = assignNextFloor(),
                                                 AttachNodeString = "Attach_Major_rcv1mhw"
                                               }
                                         }                    
                }},
            },
        })
    end
    if (_option ~= "RAMPART") then
        registerFloorAssemblage(_option .. "_" .. "WF" .. _core .. "_D", StoneGateSetPrefix .. "_WF" .. _core .. "_D", "WOOD")
        registerFloorAssemblage(_option .. "_" .. "WHITE_WF" .. _core .. "_A", StoneGateSetPrefixWhiteFloor .. "_WF" .. _core .. "_A", "WOOD")
        registerFloorAssemblage(_option .. "_" .. "WHITE_WF" .. _core .. "_B", StoneGateSetPrefixWhiteFloor .. "_WF" .. _core .. "_B", "WOOD")
        registerFloorAssemblage(_option .. "_" .. "WHITE_WF" .. _core .. "_C", StoneGateSetPrefixWhiteFloor .. "_WF" .. _core .. "_C", "WOOD")
    end
    registerFloorAssemblage(_option .. "_" .. _core .. "_TILING2", StoneGateSetPrefix .. "_" .. _core .. "_TILING2", "STONE")
    registerFloorAssemblage(_option .. "_" .. _core .. "_TILING2P", StoneGateSetPrefix .. "_" .. _core .. "_TILING2P", "STONE")
    if (_core == "OTOWER") then
        registerFloorAssemblage(_option .. "_" .. _core .. "_TILING3", StoneGateSetPrefix .. "_" .. _core .. "_TILING3", "STONE")
        registerFloorAssemblage(_option .. "_" .. _core .. "_TILING3P", StoneGateSetPrefix .. "_" .. _core .. "_TILING3P", "STONE")
    end

    if (_option ~= "RAMPART") then
-- several models of floor
        Assemblage:registerAsset({
	    DataType = "BUILDING_PART",
	    Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_FLOOR_PART",
	    ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
		            _HomePrefix .. "_" .. _option .. "_WF" .. _core .. "_D_PART",
		            _HomePrefix .. "_" .. _option .. "_WHITE_WF" .. _core .. "_A_PART",
		            _HomePrefix .. "_" .. _option .. "_WHITE_WF" .. _core .. "_B_PART",
		            _HomePrefix .. "_" .. _option .. "_WHITE_WF" .. _core .. "_C_PART",
                          }
            }
        })

-- next floor
        Assemblage:registerAsset({
	    DataType = "BUILDING_PART",
	    Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_NEXT_FLOOR_PART",
	    ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_FLOOR_PART",
                         }
            }
        })
    end

-- several models of floor
    function assignStoneFloor()
        if (_option == "RAMPART") then
            return {
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_TILING2_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_TILING2P_PART",
            }
        end
        return {
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_FLOOR_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_TILING2_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_TILING2P_PART",
        }
    end
    Assemblage:registerAsset({
	DataType = "BUILDING_PART",
	Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_STONE_FLOOR_PART",
	ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = assignStoneFloor(),
        }
    })

-- next floor
    if ((_option=="ALL") or (_option=="RAMPART")) then
        Assemblage:registerAsset({
	    DataType = "BUILDING_PART",
	    Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_STONE_NEXT_FLOOR_PART",
	    ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_RAMPART_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_STONE_FLOOR_PART",
                         }
            }
        })
    elseif (_option=="HOUSE") then
        Assemblage:registerAsset({
	    DataType = "BUILDING_PART",
	    Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_STONE_NEXT_FLOOR_PART",
	    ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = {
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_STONE_FLOOR_PART",
                         }
            }
        })
    end

    if ((_option=="ALL") or (_option == "RAMPART")) then
        if ((_core == "SST") or (_core == "SCT")) then
            function registerSstOrSctMachicollationRoof(_nameModel)
                     Assemblage:registerAsset({
        	         DataType = "BUILDING_PART",
                         Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_MACHICOLATION_ROOF_PART",
	                 ConstructorData = {
		             DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		             RandomPartList = {
                                 -- Only the Closed roofs fit on the closed machicolation rampart.
		                 StoneGateSetPrefix .. "_MACHICOLATION_" .. _core .. "_ROOF" .. _nameModel .. "45_PART", -- Closed roof
		                 StoneGateSetPrefix .. "_MACHICOLATION_" .. _core .. "_ROOF" .. _nameModel .. "30_PART", -- Closed roof
		                 StoneGateSetPrefix .. "_MACHICOLATION_" .. _core .. "_ROOF" .. _nameModel .. "60_PART", -- Closed roof
		                 StoneGateSetPrefix .. "_" .. _core .. "_POINTED_ROOF_MACHICOLATION" .. _nameModel .. "_PART",   -- Closed roof
                             }
                        }
                    })
            end
        end
        if (_core == "SST") then
            registerSstOrSctMachicollationRoof("_4CLOSED")
        elseif (_core == "SCT") then
            registerSstOrSctMachicollationRoof("")
        end

        function registerRampart(_name, _nameModel)
            Assemblage:registerAsset({
	        DataType = "BUILDING_PART",
	        Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_ROOF_PART",
                ConstructorData = {
		    DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		    CoreRandomBuildingPartList = { StoneGateSetPrefix .. "_" .. _core .. _nameModel .. "_PREFAB" },
                    AssemblageSetList = { {  DataType = "ASSEMBLAGE_CUSTOM_SET",
                                         CustomValueList = {
                                               { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_PART",
                                                 AttachNodeString = "Attach_Major_rcv1mhw"
                                               }
                                         }                    
                    }},
	        },
            })

            function registerMachicolations(_machicolationOption, _MACHICOLATIONOPTION)
                function assignMachicolationPrefab()
                    if ((_core == "MAIN") or (_core == "KEEP")) then
                        return { StoneGateSetPrefix .. "_MACHICOLATION_" .. _core .. "_PLATFORM" .. _MACHICOLATIONOPTION .. "_PREFAB" }
                    elseif ((_core == "SST") or (_core == "OTOWER") or (_core == "CIRCULAR") or (_core == "SCT"))then
                        return { StoneGateSetPrefix .. "_MACHICOLATION_" .. _core .. _nameModel .. _MACHICOLATIONOPTION .. "_PREFAB" }
                    else
                        return {}
                    end
                end
                if ((_core == "MAIN") or (_core == "KEEP")) then
                    function assignMachicolations()
                        if (_core == "MAIN") then
                            return {
                                { BuildingPart = StoneGateSetPrefix .. "_MACHICOLATION_CRENATION70_PART",
                                  AttachNodeString = "Attach_Minor_F6_sgv8mmpl" .. _machicolationOption },
                                { BuildingPart = StoneGateSetPrefix .. "_MACHICOLATION_CRENATION70_PART",
                                  AttachNodeString = "Attach_Minor_B6_sgv8mmpl" .. _machicolationOption },
                                { BuildingPart = StoneGateSetPrefix .. "_MACHICOLATION_CRENATION50_PART",
                                  AttachNodeString = "Attach_Minor_F3_sgv8mmpl" .. _machicolationOption },
                                { BuildingPart = StoneGateSetPrefix .. "_MACHICOLATION_CRENATION50_PART",
                                  AttachNodeString = "Attach_Minor_B3_sgv8mmpl" .. _machicolationOption },
                            }                    
                        end
                        if (_core == "KEEP") then
                            return {
                                { BuildingPart = StoneGateSetPrefix .. "_MACHICOLATION_CRENATION50_PART",
                                  AttachNodeString = "Attach_Minor_F1_sgv8kmpl" .. _machicolationOption },
                                { BuildingPart = StoneGateSetPrefix .. "_MACHICOLATION_CRENATION50_PART",
                                  AttachNodeString = "Attach_Minor_B1_sgv8kmpl" .. _machicolationOption },
                                { BuildingPart = StoneGateSetPrefix .. "_MACHICOLATION_CRENATION50_PART",
                                  AttachNodeString = "Attach_Minor_F2_sgv8kmpl" .. _machicolationOption },
                                { BuildingPart = StoneGateSetPrefix .. "_MACHICOLATION_CRENATION50_PART",
                                  AttachNodeString = "Attach_Minor_B2_sgv8kmpl" .. _machicolationOption },
                            }                    
                        end
                        return {}
                    end
                    Assemblage:registerAsset({
	                DataType = "BUILDING_PART",
                        Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_MACHICOLATION" .. _MACHICOLATIONOPTION .. "_PART",
                        ConstructorData = {
		            DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		            CoreRandomBuildingPartList = assignMachicolationPrefab(),
                            AssemblageSetList = { {  DataType = "ASSEMBLAGE_CUSTOM_SET",
                                                     CustomValueList = assignMachicolations(),                    
                            }},
        	        },
                    })
                end

                function assignMachicolationsAndRoof()
                    if (_core == "MAIN") then
                        return {
                            { BuildingPart = StoneGateSetPrefix .. "_MACHICOLATION_CRENATION70_PART",
                              AttachNodeString = "Attach_Minor_F6_sgv8mmpl" .. _machicolationOption },
                            { BuildingPart = StoneGateSetPrefix .. "_MACHICOLATION_CRENATION70_PART",
                              AttachNodeString = "Attach_Minor_B6_sgv8mmpl" .. _machicolationOption },
                            { BuildingPart = StoneGateSetPrefix .. "_MACHICOLATION_CRENATION50_PART",
                              AttachNodeString = "Attach_Minor_F3_sgv8mmpl" .. _machicolationOption },
                            { BuildingPart = StoneGateSetPrefix .. "_MACHICOLATION_CRENATION50_PART",
                              AttachNodeString = "Attach_Minor_B3_sgv8mmpl" .. _machicolationOption },
                            { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_MACHICOLATION_ROOF_PART",
                              AttachNodeString = "Attach_Major_machicolation_high_sgv8mmpl" .. _machicolationOption },
                        }                    
                    end
                    if (_core == "KEEP") then
                        return {
                            { BuildingPart = StoneGateSetPrefix .. "_MACHICOLATION_CRENATION50_PART",
                              AttachNodeString = "Attach_Minor_F1_sgv8kmpl" .. _machicolationOption },
                            { BuildingPart = StoneGateSetPrefix .. "_MACHICOLATION_CRENATION50_PART",
                              AttachNodeString = "Attach_Minor_B1_sgv8kmpl" .. _machicolationOption },
                            { BuildingPart = StoneGateSetPrefix .. "_MACHICOLATION_CRENATION50_PART",
                              AttachNodeString = "Attach_Minor_F2_sgv8kmpl" .. _machicolationOption },
                            { BuildingPart = StoneGateSetPrefix .. "_MACHICOLATION_CRENATION50_PART",
                              AttachNodeString = "Attach_Minor_B2_sgv8kmpl" .. _machicolationOption },
                            { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_MACHICOLATION_ROOF_PART",
                              AttachNodeString = "Attach_Major_machicolation_high_sgv8kmpl" .. _machicolationOption },
                        }                    
                    end
                    if ((_core == "SST") or (_core == "SCT")) then
                        return {
                            { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_MACHICOLATION_ROOF_PART",
                              AttachNodeString = "Attach_Major_rcv1mhw" },
                        }                    
                    end
                    if ((_core == "OTOWER") or (_core == "CIRCULAR")) then
                        return {
                            { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_MACHICOLATION_ROOF_PART",
                              AttachNodeString = "Attach_Major_rcv1mhw" },
                        }                    
                    end
                    return {}
                end
                Assemblage:registerAsset({
	            DataType = "BUILDING_PART",
                    Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_MACHICOLATION" .. _MACHICOLATIONOPTION .. "_WITH_ROOF_PART",
                    ConstructorData = {
		        DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		        CoreRandomBuildingPartList = assignMachicolationPrefab(),
                        AssemblageSetList = { {  DataType = "ASSEMBLAGE_CUSTOM_SET",
                                                 CustomValueList = assignMachicolationsAndRoof(),                    
                        }},
	            },
                })
            end
            if ((_core == "MAIN") or (_core == "KEEP") or (_core == "OTOWER") or (_core == "CIRCULAR")) then
                Assemblage:registerAsset({
	            DataType = "BUILDING_PART",
                    Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_MACHICOLATION_ROOF_PART",
                    ConstructorData = {
		        DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		        CoreRandomBuildingPartList = { StoneGateSetPrefix .. "_MACHICOLATION_" .. _core .. "_ROOF_PLATFORM_PREFAB" },
                        AssemblageSetList = {{ DataType = "ASSEMBLAGE_CUSTOM_SET",
                                               CustomValueList = {{ BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_PART",
                                                                    AttachNodeString = "Attach_Major_rcv1mhw" },},
                        }},
	            },
                })
                registerMachicolations("", "")
                registerMachicolations("p", "P")
            elseif ((_core == "SST") or (_core == "SCT")) then
                registerMachicolations("", "")
                registerMachicolations("p", "P")
            end

            function assignRampart()
                    if (_option == "RAMPART") then
                        if (_core == "SCT") then
                            return  {
	        	        StoneGateSetPrefix .. "_" .. _core .. _nameModel .. "_PART",
		                _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_ROOF_PART",
		                StoneGateSetPrefix .. "_MACHICOLATION_" .. _core .. _nameModel .. "_PART",
		                _HomePrefix .. "_" .. _option .. "_" .. _core .. "_MACHICOLATION_WITH_ROOF_PART",
		                StoneGateSetPrefix .. "_MACHICOLATION_" .. _core .. _nameModel .. "P_PART",
		                _HomePrefix .. "_" .. _option .. "_" .. _core .. "_MACHICOLATIONP_WITH_ROOF_PART",
                            }
                        end
                        if ((_core == "MAIN") or (_core == "KEEP")) then
                            return  {
		                StoneGateSetPrefix .. "_" .. _core .. _nameModel .. "_PART",
		                _HomePrefix .. "_" .. _option .. "_" .. _core .. "_MACHICOLATION_PART",
		                _HomePrefix .. "_" .. _option .. "_" .. _core .. "_MACHICOLATION_WITH_ROOF_PART",
		                _HomePrefix .. "_" .. _option .. "_" .. _core .. "_MACHICOLATIONP_PART",
		                _HomePrefix .. "_" .. _option .. "_" .. _core .. "_MACHICOLATIONP_WITH_ROOF_PART",
		                _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_ROOF_PART",
		                _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_HOARDING_PART",
		                _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_HOARDING_AND_ROOF_PART",
                            }
                        end
                        if ((_core == "SST") or (_core == "OTOWER") or (_core == "CIRCULAR")) then
                            return  {
		                StoneGateSetPrefix .. "_" .. _core .. _nameModel .. "_PART",
		                StoneGateSetPrefix .. "_MACHICOLATION_" .. _core .. _nameModel .. "_PART",
		                _HomePrefix .. "_" .. _option .. "_" .. _core .. "_MACHICOLATION_WITH_ROOF_PART",
		                StoneGateSetPrefix .. "_MACHICOLATION_" .. _core .. _nameModel .. "P_PART",
		                _HomePrefix .. "_" .. _option .. "_" .. _core .. "_MACHICOLATIONP_WITH_ROOF_PART",
		                _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_ROOF_PART",
		                _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_HOARDING_PART",
		                _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_HOARDING_AND_ROOF_PART",
                            }
                        end
                        return  {
		            StoneGateSetPrefix .. "_" .. _core .. _nameModel .. "_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_ROOF_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_HOARDING_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_HOARDING_AND_ROOF_PART",
                        }
                    end
                    -- default case: ALL
                    if (_core == "SCT") then
                        return  {
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_PART",
	        	    StoneGateSetPrefix .. "_" .. _core .. _nameModel .. "_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_ROOF_PART",
                        }
                    end
                    if ((_core == "MAIN") or (_core == "KEEP")) then
                        return {
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_PART",
		            StoneGateSetPrefix .. "_" .. _core .. _nameModel .. "_PART",
                            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_MACHICOLATION_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_MACHICOLATION_WITH_ROOF_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_MACHICOLATIONP_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_MACHICOLATIONP_WITH_ROOF_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_ROOF_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_HOARDING_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_HOARDING_AND_ROOF_PART",
                        }
                    end
                    if ((_core == "SST") or (_core == "OTOWER") or (_core == "CIRCULAR")) then
                        return  {
        		    _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_PART",
		            StoneGateSetPrefix .. "_" .. _core .. _nameModel .. "_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_" .. _core .. _nameModel .. "_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_MACHICOLATION_WITH_ROOF_PART",
		            StoneGateSetPrefix .. "_MACHICOLATION_" .. _core .. _nameModel .. "P_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_MACHICOLATIONP_WITH_ROOF_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_ROOF_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_HOARDING_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_HOARDING_AND_ROOF_PART",
                        }
                    end
                    return {
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_PART",
		            StoneGateSetPrefix .. "_" .. _core .. _nameModel .. "_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_ROOF_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_HOARDING_PART",
		            _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_HOARDING_AND_ROOF_PART",
                    }
            end
            Assemblage:registerAsset({
	            DataType = "BUILDING_PART",
                    Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_PART",
	            ConstructorData = {
		          DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		          RandomPartList = assignRampart(),
                    }
            })
    
            function assignHoarding()
                    if (_core == "MAIN") then
                        return {
                            { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S3L1R1_PART",
                              AttachNodeString = "Attach_Minor_F6_sgv8msr4c" },
                            { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S3L1R1_PART",
                              AttachNodeString = "Attach_Minor_B6_sgv8msr4c" },
                            { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S2L1R1_PART",
                              AttachNodeString = "Attach_Minor_R4_sgv8msr4c" },
                            { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S2L1R1_PART",
                              AttachNodeString = "Attach_Minor_L4_sgv8msr4c" },
                        }                    
                    end
                    if (_core == "KEEP") then
                        return {
                            { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S2L1R1_PART",
                              AttachNodeString = "Attach_Minor_F6_sgv8ksr4c" },
                            { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S2L1R1_PART",
                              AttachNodeString = "Attach_Minor_B6_sgv8ksr4c" },
                            { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S2L1R1_PART",
                              AttachNodeString = "Attach_Minor_R4_sgv8ksr4c" },
                            { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S2L1R1_PART",
                              AttachNodeString = "Attach_Minor_L4_sgv8ksr4c" },
                        }                    
                    end
                    if (_core == "SST") then
                        return {
                            { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S1_4CLOSED_PART",
                              AttachNodeString = "Attach_Major_rcv1mhw" },
                        }                    
                    end
                    if (_core == "OTOWER") then
                        return {
                            { BuildingPart = StoneGateSetPrefix .. "_OTOWER_HOARDING_PART",
                              AttachNodeString = "Attach_Minor_LB_sgv8otsr" },
                            { BuildingPart = StoneGateSetPrefix .. "_OTOWER_HOARDING_PART",
                              AttachNodeString = "Attach_Minor_RB_sgv8otsr" },
                            { BuildingPart = StoneGateSetPrefix .. "_OTOWER_HOARDING_PART",
                              AttachNodeString = "Attach_Minor_LF_sgv8otsr" },
                            { BuildingPart = StoneGateSetPrefix .. "_OTOWER_HOARDING_PART",
                              AttachNodeString = "Attach_Minor_RF_sgv8otsr" },
                            { BuildingPart = StoneGateSetPrefix .. "_OTOWER_HOARDING_PART",
                              AttachNodeString = "Attach_Minor_L_sgv8otsr" },
                            { BuildingPart = StoneGateSetPrefix .. "_OTOWER_HOARDING_PART",
                              AttachNodeString = "Attach_Minor_R_sgv8otsr" },
                            { BuildingPart = StoneGateSetPrefix .. "_OTOWER_HOARDING_PART",
                              AttachNodeString = "Attach_Minor_B_sgv8otsr" },
                            { BuildingPart = StoneGateSetPrefix .. "_OTOWER_HOARDING_PART",
                              AttachNodeString = "Attach_Minor_F_sgv8otsr" },
                        }                    
                    end
                    if (_core == "CIRCULAR") then
                        return {
                            { BuildingPart = StoneGateSetPrefix .. "_CIRCULAR_HOARDING_PART",
                              AttachNodeString = "Attach_Major_rcv1mhw" },
                        }                    
                    end
                    return {}
                end
                Assemblage:registerAsset({
	            DataType = "BUILDING_PART",
	            Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_HOARDING_PART",
	            ConstructorData = {
		        DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
                        CoreRandomBuildingPartList = { StoneGateSetPrefix .. "_" .. _core .. _nameModel .. "_PREFAB" },
                        AssemblageSetList = { {  DataType = "ASSEMBLAGE_CUSTOM_SET",
                                                 CustomValueList = assignHoarding()                    
                        }},
	            },
            })

            function assignHoardingAndRoof()
                    if (_core == "MAIN") then
                        return {
                            { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S3L1R1_PART",
                              AttachNodeString = "Attach_Minor_F6_sgv8msr4c" },
                            { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S3L1R1_PART",
                              AttachNodeString = "Attach_Minor_B6_sgv8msr4c" },
                            { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S2L1R1_PART",
                              AttachNodeString = "Attach_Minor_R4_sgv8msr4c" },
                            { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S2L1R1_PART",
                              AttachNodeString = "Attach_Minor_L4_sgv8msr4c" },
                            { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_PART",
                              AttachNodeString = "Attach_Major_rampart_high2_sgv8msr4c" },
                        }                    
                    end
                    if (_core == "KEEP") then
                        return {
                            { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S2L1R1_PART",
                              AttachNodeString = "Attach_Minor_F6_sgv8ksr4c" },
                            { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S2L1R1_PART",
                              AttachNodeString = "Attach_Minor_B6_sgv8ksr4c" },
                            { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S2L1R1_PART",
                              AttachNodeString = "Attach_Minor_R4_sgv8ksr4c" },
                            { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S2L1R1_PART",
                              AttachNodeString = "Attach_Minor_L4_sgv8ksr4c" },
                            { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_PART",
                              AttachNodeString = "Attach_Major_rampart_high2_sgv8ksr4c" },
                        }                    
                    end
                    if (_core == "SST") then
                        return {
                            { BuildingPart = StoneGateSetPrefix .. "_HOARDING_S1_4CLOSED_PART",
                              AttachNodeString = "Attach_Major_rcv1mhw" },
                            { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_PART",
                              AttachNodeString = "Attach_Major_rampart_high2_sgv8sstsr4c" },
                        }                    
                    end
                    if (_core == "OTOWER") then
                        return {
                            { BuildingPart = StoneGateSetPrefix .. "_OTOWER_HOARDING_PART",
                              AttachNodeString = "Attach_Minor_LB_sgv8otsr" },
                            { BuildingPart = StoneGateSetPrefix .. "_OTOWER_HOARDING_PART",
                              AttachNodeString = "Attach_Minor_RB_sgv8otsr" },
                            { BuildingPart = StoneGateSetPrefix .. "_OTOWER_HOARDING_PART",
                              AttachNodeString = "Attach_Minor_LF_sgv8otsr" },
                            { BuildingPart = StoneGateSetPrefix .. "_OTOWER_HOARDING_PART",
                              AttachNodeString = "Attach_Minor_RF_sgv8otsr" },
                            { BuildingPart = StoneGateSetPrefix .. "_OTOWER_HOARDING_PART",
                              AttachNodeString = "Attach_Minor_L_sgv8otsr" },
                            { BuildingPart = StoneGateSetPrefix .. "_OTOWER_HOARDING_PART",
                              AttachNodeString = "Attach_Minor_R_sgv8otsr" },
                            { BuildingPart = StoneGateSetPrefix .. "_OTOWER_HOARDING_PART",
                              AttachNodeString = "Attach_Minor_B_sgv8otsr" },
                            { BuildingPart = StoneGateSetPrefix .. "_OTOWER_HOARDING_PART",
                              AttachNodeString = "Attach_Minor_F_sgv8otsr" },
                            { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_PART",
                              AttachNodeString = "Attach_Major_rampart_high2_sgv8otsr" },
                        }                    
                    end
                    if (_core == "CIRCULAR") then
                        return {
                            { BuildingPart = StoneGateSetPrefix .. "_CIRCULAR_HOARDING_PART",
                              AttachNodeString = "Attach_Major_rcv1mhw" },
                            { BuildingPart = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_WOOD_ROOF_PART",
                              AttachNodeString = "Attach_Major_rampart_high2_sgv8csr" },
                        }                    
                    end
                    return {}
            end

            Assemblage:registerAsset({
	            DataType = "BUILDING_PART",
	            Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. _name .. "_WITH_HOARDING_AND_ROOF_PART",
	            ConstructorData = {
		        DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		        CoreRandomBuildingPartList = { StoneGateSetPrefix .. "_" .. _core .. _nameModel .. "_PREFAB" },
                        AssemblageSetList = { {  DataType = "ASSEMBLAGE_CUSTOM_SET",
                                         CustomValueList = assignHoardingAndRoof()                    
                        }},
	            },
            })
        end    

        if ((_core == "OTOWER") or (_core == "CIRCULAR")) then
            registerRampart("_RAMPART", "_RAMPART")
        elseif (_core == "SCT") then
            registerRampart("_RAMPART", "_RAMPART_CLOSED")
        else
            registerRampart("_RAMPART", "_RAMPART_4CLOSED")
        end
    end
    registerGroundFloorAssemblage(_option .. "_" .. _core .. "_TILING1", StoneGateSetPrefix .. "_" .. _core .. "_TILING1_PREFAB", "STONE")
    registerGroundFloorAssemblage(_option .. "_" .. _core .. "_TILING1P", StoneGateSetPrefix .. "_" .. _core .. "_TILING1P_PREFAB", "STONE")
    if (_option ~= "RAMPART") then
        registerGroundFloorAssemblage(_option .. "_" .. _core .. "_TILING1HALFWHITE", StoneGateSetPrefix .. "_" .. _core .. "_TILING1HALFWHITE_PREFAB", "WOOD")
    end

    function assignBasement()
        if (_option == "RAMPART") then
            return {
                    _HomePrefix .. "_" .. _option .. "_" .. _core .. "_TILING1_PART",
                    _HomePrefix .. "_" .. _option .. "_" .. _core .. "_TILING1P_PART",
	    }
        end
        return {
                    _HomePrefix .. "_" .. _option .. "_" .. _core .. "_TILING1_PART",
                    _HomePrefix .. "_" .. _option .. "_" .. _core .. "_TILING1P_PART",
                    _HomePrefix .. "_" .. _option .. "_" .. _core .. "_TILING1HALFWHITE_PART",
	}
    end
    function registerPlaceableHouse()
        Assemblage:registerAsset({
	    DataType = "BUILDING_PART",
	    Id = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_PART",
	    Name = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_NAME",
	    Description = _HomePrefix .. "_" .. _option .. "_" .. _core .. "_DESC",
	    Category = "CORE",
	    BuildingZone = _buildingZone,
	    ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = assignBasement(),
            },
            VillagerCapacity = _villagerCapacity,
	    AssetBuildingFunction = registerAssignableFunction(_HomePrefix, _option .. "_" .. _core)
        })
    end

    registerPlaceableHouse()
end

function registerOptions(_core, _buildingZone, _villagerCapacity)
    registerRandomCore("ALL", _core, _buildingZone, _villagerCapacity)
    registerRandomCore("HOUSE", _core, _buildingZone, _villagerCapacity)
    registerRandomCore("RAMPART", _core, _buildingZone, _villagerCapacity)
end

registerOptions("MAIN", _MainBuildingZone, 6)
registerOptions("KEEP", _KeepBuildingZone, 4)
registerOptions("SST", _SstBuildingZone, 1)
registerOptions("OTOWER", _OTowerBuildingZone, 5)
registerOptions("CIRCULAR", _CircularBuildingZone, 3)
registerOptions("SCT", _SmallCircularBuildingZone, 1)
